com.fasterxml.jackson.databind.deser.impl

## Class BeanAsArrayBuilderDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.BeanDeserializerBase
      - - com.fasterxml.jackson.databind.deser.impl.BeanAsArrayBuilderDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, ResolvableDeserializer, ValueInstantiator.Gettable, Serializable

      public class BeanAsArrayBuilderDeserializer
      extends BeanDeserializerBase

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AnnotatedMethod` | `_buildMethod`
    `protected BeanDeserializerBase` | `_delegate` Deserializer we delegate operations that we cannot handle.
    `protected SettableBeanProperty[]` | `_orderedProperties` Properties in order expected to be found in JSON array.
    `protected JavaType` | `_targetType` Type that the builder will produce, target type; as opposed to `handledType()` which refers to Builder class.

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_anySetter, _arrayDelegateDeserializer, _backRefs, _beanProperties, _beanType, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _serializationShape, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing, TEMP_PROPERTY_NAME`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BeanAsArrayBuilderDeserializer(BeanDeserializerBase delegate, JavaType targetType, SettableBeanProperty[] ordered, AnnotatedMethod buildMethod)` Main constructor used both for creating new instances (by `BeanDeserializer.asArrayDeserializer()`) and for creating copies with different delegate.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `_deserializeFromNonArray(JsonParser p, DeserializationContext ctxt)`
    `protected Object` | `_deserializeNonVanilla(JsonParser p, DeserializationContext ctxt)` Alternate deserialization method that has to check many more configuration aspects than the "vanilla" processing.
    `protected Object` | `_deserializeUsingPropertyBased(JsonParser p, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
    `protected BeanDeserializerBase` | `asArrayDeserializer()` Fluent factory for creating a variant that can handle POJO output as a JSON Array.
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt, Object value)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeFromObject(JsonParser p, DeserializationContext ctxt)` General version used when handling needs more advanced features.
    `protected Object` | `finishBuild(DeserializationContext ctxt, Object builder)`
    `Boolean` | `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
    `JsonDeserializer<Object>` | `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
    `BeanDeserializerBase` | `withBeanProperties(BeanPropertyMap props)` Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
    `BeanDeserializerBase` | `withIgnorableProperties(Set<String> ignorableProps)`
    `BeanDeserializerBase` | `withObjectIdReader(ObjectIdReader oir)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_convertObjectId, _findPropertyUnwrapper, _findSubclassDeserializer, _handleTypedObjectId, _replaceProperty, _resolvedObjectIdProperty, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveMergeAndNullSettings, createContextual, creatorProperties, deserializeFromArray, deserializeFromBoolean, deserializeFromDouble, deserializeFromEmbedded, deserializeFromNumber, deserializeFromObjectId, deserializeFromObjectUsingNonDefault, deserializeFromString, deserializeWithObjectId, deserializeWithType, findBackReference, findConvertingDeserializer, findProperty, findProperty, findProperty, getBeanClass, getEmptyAccessPattern, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handledType, handleIgnoredProperty, handlePolymorphic, handleUnknownProperties, handleUnknownProperty, handleUnknownVanilla, hasProperty, hasViews, injectValues, isCachable, properties, replaceProperty, resolve, wrapAndThrow, wrapInstantiationProblem`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, handleMissingEndArrayForSingle, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `getDelegatee, getEmptyValue, getNullValue, getNullValue, replaceDelegatee`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _delegate

          protected final BeanDeserializerBase _delegate

      Deserializer we delegate operations that we cannot handle.

    - #### _orderedProperties

          protected final SettableBeanProperty[] _orderedProperties

      Properties in order expected to be found in JSON array.

    - #### _buildMethod

          protected final AnnotatedMethod _buildMethod

    - #### _targetType

          protected final JavaType _targetType

      Type that the builder will produce, target type; as opposed to `handledType()` which refers to Builder class.
      Since:
        2.9

  - ### Constructor Detail

    - #### BeanAsArrayBuilderDeserializer

          public BeanAsArrayBuilderDeserializer(BeanDeserializerBase delegate,
                                                JavaType targetType,
                                                SettableBeanProperty[] ordered,
                                                AnnotatedMethod buildMethod)

      Main constructor used both for creating new instances (by `BeanDeserializer.asArrayDeserializer()`) and for creating copies with different delegate.
      Since:
        2.9

  - ### Method Detail

    - #### unwrappingDeserializer

          public JsonDeserializer<Object> unwrappingDeserializer(NameTransformer unwrapper)

      Description copied from class: `JsonDeserializer`
      Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

      Default implementation just returns 'this' indicating that no unwrapped variant exists

      Specified by:
        `unwrappingDeserializer` in class `BeanDeserializerBase`

    - #### withObjectIdReader

          public BeanDeserializerBase withObjectIdReader(ObjectIdReader oir)

      Specified by:
        `withObjectIdReader` in class `BeanDeserializerBase`

    - #### withIgnorableProperties

          public BeanDeserializerBase withIgnorableProperties(Set<String> ignorableProps)

      Specified by:
        `withIgnorableProperties` in class `BeanDeserializerBase`

    - #### withBeanProperties

          public BeanDeserializerBase withBeanProperties(BeanPropertyMap props)

      Description copied from class: `BeanDeserializerBase`
      Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
      Overrides:
        `withBeanProperties` in class `BeanDeserializerBase`

    - #### asArrayDeserializer

          protected BeanDeserializerBase asArrayDeserializer()

      Description copied from class: `BeanDeserializerBase`
      Fluent factory for creating a variant that can handle POJO output as a JSON Array. Implementations may ignore this request if no such input is possible.
      Specified by:
        `asArrayDeserializer` in class `BeanDeserializerBase`

    - #### supportsUpdate

          public Boolean supportsUpdate(DeserializationConfig config)

      Description copied from class: `JsonDeserializer`
      Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

      Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

      Default implementation returns `null` to allow explicit per-type or per-property attempts.

      Overrides:
        `supportsUpdate` in class `BeanDeserializerBase`

    - #### finishBuild

          protected final Object finishBuild(DeserializationContext ctxt,
                                             Object builder)
                                      throws IOException

      Throws:
        `IOException`

    - #### deserialize

          public Object deserialize(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.getCurrentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserialize

          public Object deserialize(JsonParser p,
                                    DeserializationContext ctxt,
                                    Object value)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<Object>`
      Throws:
        `IOException`

    - #### deserializeFromObject

          public Object deserializeFromObject(JsonParser p,
                                              DeserializationContext ctxt)
                                       throws IOException

      Description copied from class: `BeanDeserializerBase`
      General version used when handling needs more advanced features.
      Specified by:
        `deserializeFromObject` in class `BeanDeserializerBase`
      Throws:
        `IOException`

    - #### _deserializeNonVanilla

          protected Object _deserializeNonVanilla(JsonParser p,
                                                  DeserializationContext ctxt)
                                           throws IOException

      Alternate deserialization method that has to check many more configuration aspects than the "vanilla" processing. Note: should NOT resolve builder; caller will do that
      Returns:
        Builder object in use.
      Throws:
        `IOException`

    - #### _deserializeUsingPropertyBased

          protected final Object _deserializeUsingPropertyBased(JsonParser p,
                                                                DeserializationContext ctxt)
                                                         throws IOException

      Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.
      Specified by:
        `_deserializeUsingPropertyBased` in class `BeanDeserializerBase`
      Throws:
        `IOException`

    - #### _deserializeFromNonArray

          protected Object _deserializeFromNonArray(JsonParser p,
                                                    DeserializationContext ctxt)
                                             throws IOException

      Throws:
        `IOException`

Copyright © 2008–2018 FasterXML. All rights reserved.